function [ ct,count ] = pNCG(OCP )
yd=desiredState1(OCP);
u=0*ones((OCP.N-1)*OCP.Nt,1);
Jg(u,yd,OCP);
g=get_grad(u,yd,OCP);
d=-g;
count=0;
dQ=(OCP.b-OCP.a)*OCP.T*(1/(OCP.N*OCP.Nt));
t=1;
tol_t=10^-14;
ctime=cputime;
res=inf;
while(res>=OCP.res_conv && t>=tol_t)  %(sqrt(sum((u-proj(u-g)).^2)*dQ)>res && t>=tol_t)
    u_old=u;
    t=get_WPS(u,yd,t,d,tol_t,OCP);
    u=proj(u+t*d);
    g_alt=g;
    g=get_grad(u,yd,OCP);
    y=g-g_alt;
    sigma_HZ=y-2*d*((y')*y)/(y'*d);
    beta_HZ=(sigma_HZ'*g)/(d'*y);
    d=-g+beta_HZ*d;
    %test_grad(alpha, beta, gamma, dx, dt, N, Nt,s,D, f0, fd,f,u,gp, gq, lambda, jc)
    %test_graduJ(alpha, beta, gamma, N, Nt,f0, fd,dt,dx,u)
    %test_gradfJ(alpha, beta, gamma, N,Nt,f,fd,f0,dt,dx,u)
    count=count+1;
    res=sum((u-u_old).^2)*dQ;
end
if t<tol_t
    fprintf('t too small\n');
end
ct=cputime-ctime;
f=zeros(OCP.Nt*(OCP.N+1),1);
y0=zeros((OCP.N+1),1);
y=implForward(u,y0,f,OCP);
[X,T]=meshgrid(OCP.a:(OCP.b-OCP.a)/OCP.N:OCP.b,0:OCP.T/OCP.Nt:OCP.T);
[Xu,Tu]=meshgrid((OCP.a+(OCP.b-OCP.a)/OCP.N):(OCP.b-OCP.a)/OCP.N:(OCP.b-(OCP.b-OCP.a)/OCP.N),0+OCP.T/OCP.Nt:OCP.T/OCP.Nt:OCP.T);
figure('Name','yg')
 mesh(X,T,reshape(y,[OCP.N+1,OCP.Nt+1])')
 xlabel('x');
 ylabel('t');
 figure('Name','ug')
 mesh(Xu,Tu,reshape(u,[OCP.N-1,OCP.Nt])')
 xlabel('x');
 ylabel('t');

 J_last_NCG=Jg(u,yd,OCP)


end

function [g]= get_grad(u,yd,OCP)
N=OCP.N;
Nt=OCP.Nt;
f=zeros(OCP.Nt*(OCP.N+1),1);
y0=zeros((OCP.N+1),1);

y=implForward(u,y0,f,OCP);
p=implBackward(y,yd, OCP);

for j=1:Nt
   g((j-1)*(N-1)+1:j*(N-1),1)=OCP.alpha*u((j-1)*(N-1)+1:j*(N-1),1)+OCP.beta+p((j-1)*(N+1)+2:j*(N+1)-1,1);
end

end

function [ u ] = proj( u)
u=min(max(0,u),10);
end

function [J]=Jg(u,yd,OCP)
J=0;
f=zeros(OCP.Nt*(OCP.N+1),1);
y0=zeros((OCP.N+1),1);
y=implForward(u,y0,f,OCP);
N=OCP.N;
Nt=OCP.Nt;
d=(OCP.b-OCP.a)*OCP.T/(N*Nt);
J=(0.5*d*transpose((y-yd))*(y-yd))+(0.5*OCP.alpha*d*(transpose(u)*u))+OCP.beta*d*sum(abs(u).*(abs(u)>OCP.s));
end

function[t]=get_WPS(u,yd,t,d,tol_t,OCP)
tau1=0.3;
tau2=0.4;
gamma_WPS=5.1;
found=0;
delta=0.01;
sigma=0.9;
Minimi=OCP.u_lo;
Maximi=OCP.u_up;
dQ=(OCP.b-OCP.a)*OCP.T*(1/(OCP.N*OCP.Nt));
epsilon_rand=0;
J=Jg(u,yd,OCP);
grad=get_grad(u,yd,OCP);
%for n=1:Nt
    if(max(u==Minimi))
        epsilon_rand=1;
        %fprintf('Auf dem unterem Rand');
    %    break;
    end
    if(max(u==Maximi))
        epsilon_rand=1;
       % fprintf('Auf dem oberen Rand');
     %   break;
    end
%end
    if(epsilon_rand==1 && (min(Minimi<=u+(10^-6)*(d/(dQ*norm(d))))==0 || min(u+(10^-6)*(d/(dQ*norm(d)))<=Maximi)==0))
        d_tilde=0*d;
       % fprintf('hier\n');
    else
        d_tilde=d;
    end
%d_tilde ende

    zu2=1;
    zu3=1;
    zu4=1;
    zu5=1;
while(found==0)
    if (t<tol_t)
        %fprintf('t zu klein');
        break;
    end
   % fprintf('Schleife 1\n');
   
    while(zu2==1)
       % fprintf('Schleife 2\n');
       ut=proj(u+t*d);
        if(Jg(ut,yd,OCP)>(J+delta*t*dQ*(d_tilde')*grad))
    %        fprintf('Test1\n');
            break;
        else
            if(get_grad(ut,yd,OCP)'*d_tilde>=sigma*grad'*d_tilde)
                found=1;
                zu2=0;
                zu3=0;
                zu4=0;
                zu5=0;
      %          fprintf('ja1\n');
                break;
            end
           t=gamma_WPS*t;
        end
        
    end
    while(zu3==1) 
      %  fprintf('Schleife 3\n');
        a=0;
        b=t;
        zu3=0;
        
    end
    while(zu4==1)
   %     fprintf('Schleife 4\n');
   if (t<tol_t)
            break;
   end
        t=0.5*(a+tau1*(b-a)+b-tau2*(b-a));
        zu4=0;
    end
    while(zu5==1)
        if (t<tol_t)
            break;
        end
        ut=proj(u+t*d);
       % fprintf('Schleife 5\n');
        if(Jg(ut,yd,OCP)>(J+delta*t*dQ*(d_tilde')*grad))
          %  fprintf('Test2\n');
            b=t;
            zu2=0;
            zu3=0;
            zu4=1;
            zu5=1;
            break;
        else
%             dj2=dJ(alpha,h,epsilon+t*d,A,N,vd)'*d
%             dj1=sigma*dJ(alpha,h,epsilon,A,N,vd)'*d_tilde
            if(get_grad(ut,yd,OCP)'*d_tilde>=sigma*grad'*d_tilde)
              % fprintf('Test3\n');
                found=1;
                zu2=0;
                zu3=0;
                zu4=0;
                zu5=0;
        %        fprintf('ja2\n');
                break;
            end
            a=t;
            zu2=0;
            zu3=0;
            zu4=1;
            zu5=1;
            break;
        end
    end
end

end

