%% First ODE (discretization of the differential part)
% Predictor corrector scheme to solve the ODE containing the discretization
% of the differential operator
function [f_new] = first_ode(NX, dx, x, dt, f_old, t_old, t_new, u_old, u_new)    

% %% first order
%     
%     [Mnew] = matrix_cc(NX, dx, x, dt, t_new, u_new);
%     
%     M = eye(NX+1) - (dt*0.5) .* Mnew ;
%     
%     f_new = M \ f_old;

%% second order

    [Mold] = matrix_cc(NX, dx, x, dt, t_old, u_old);
    
    [Mnew] = matrix_cc(NX, dx, x, dt, t_new, u_new);
    
    M = eye(NX+1) + (dt*0.5) .* ( Mold + Mnew + dt.* (Mold*Mnew) );
    
    f_new = M * f_old;
    
%     f_norm = ( 1 / dx ) * f_new ./ sum(f_new);
%     
%     f_new = f_norm;
    
    
end