% test controlled MC 2 dim
clear 


fname='data_traj_split.mat';
load(fname);   % all data needed for the simulation



% number of desired trajectories
Nsample=5;
Ntime = 300; % number of time points for the Milstein integration


T=T1-T0;

[ Nx1, Nx2, Nt] = size(u1);

D1 = linspace(a,b,Nx1);
D2 = linspace(a,b,Nx2);
TT = linspace(0,T,Nt);

% interpolate controls: 

model

x00 = -2.1+0*ip(1);  x01=-3.1+0*ip(2); %Starting points of the stochastic process


% Integrate the stochastic process
[y, t] = milstein_2D(m,x00,x01,u1,u2,Nsample,T,Ntime);

hold on
figure(4)
% plot(y(:,:,1),y(:,:,2),'Color',[0.5 0.5 0.5]);
 plot(y(:,:,1),y(:,:,2));
 xlabel('x_1')
 ylabel('x_2')
 hold on;
 axis([a b a  b]);
 T=1;
dt=0.01;

 xd=get_xd(T,dt);
plot(xd(1,:),xd(2,:),'--')
 