%Calculation of the pointwise minimum of the augmented Hamiltonian with a
%secant method
function [ v ] = argminH(i,j,p,u,epsilon,f,OCP )
posi=(j-1)*(OCP.N+1)+1+i;

if (OCP.beta==0)
     v=min(max((2*epsilon*u-p(posi))/(OCP.alpha+2*epsilon),OCP.u_lo),OCP.u_up); %If beta=0 use this analytical formula
else
    %Secant method
    num_Int=100;
    Disc_KU=linspace(OCP.u_lo,OCP.u_up,num_Int);
    dist=inf;

    while(dist>10^-12)
    [~,pos]=min((OCP.alpha/2)*Disc_KU.^2+OCP.beta*(1*(abs(Disc_KU)>OCP.s)+2.5*(abs(Disc_KU)>2*OCP.s))+(Disc_KU+f(posi)).*p(posi)+epsilon*((Disc_KU-u).^2));
    v=Disc_KU(pos);
    %Refine the search interval depending on the actual minimum of the
    %Hamiltonain
    if (pos==1)
    Disc_KU=linspace(Disc_KU(pos),Disc_KU(pos+1),num_Int);
    dist=(Disc_KU(pos+1)-Disc_KU(pos));
    elseif  (pos==max(size(Disc_KU)))
    Disc_KU=linspace(Disc_KU(pos-1),Disc_KU(pos),num_Int);
    dist=(Disc_KU(pos)-Disc_KU(pos-1));
    else
    Disc_KU=linspace(Disc_KU(pos-1),Disc_KU(pos+1),num_Int);
    dist=Disc_KU(pos+1)-Disc_KU(pos-1);
    end
    end
end

end


