%Numerical PMP test
function [] = optimal(u,w,ya,umax, wmax, OCP)

[x,t]=expliciteuler(@F,ya,u,w,OCP);
lambda=eulerback(@H,t,x,u,w,OCP);
n=OCP.n;

sigma=OCP.sigma;
nu_u=OCP.nu_u;
nu_w=OCP.nu_w;
mu_u=OCP.mu_u;
mu_w=OCP.mu_w;
xi=OCP.xi;
alpha=OCP.alpha;
beta=OCP.beta;
kappa=OCP.kappa;
b=OCP.b;
d=OCP.d;
gamma=OCP.gamma;
eta=OCP.eta;
delta=OCP.delta;
rho=OCP.rho;
epsilon=0;


for i=1:n
       %Calculation of the values of the Hamiltonian with the results from
       %the SQH method
       Hopt(i)=sigma/2*x(i,1)^2+nu_u/2*u(i).*u(i)+nu_w/2*w(i).*w(i)...
                +mu_u*abs(u(i))+mu_w*abs(w(i))-lambda(i,1)...
                *(xi*x(i,1)*log(x(i,1)/x(i,2))+(alpha+beta*x(i,3))*x(i,1)*w(i))...
                +lambda(i,2)*(kappa*(b*x(i,2)^(2/3)-d*x(i,2)^(4/3))...
                +(1-kappa)*(b*x(i,1)-d*x(i,1)^(2/3)*x(i,2)))...
                -lambda(i,2)*(gamma*x(i,2)*u(i)+(eta+delta*x(i,3))*x(i,2)*w(i))...
                +lambda(i,3)*(-rho*x(i,3)+w(i));
            
           
end

for i=1:n
        %Calculation of the minimum of the Hamiltonian with state and
        %adjoint from the SQH method and the corresponding values of the
        %Hamiltonian
        u(i)=min(max(0,(-mu_u+lambda(i,2)*gamma*x(i,2)+2*epsilon*u(i))/(nu_u+2*epsilon)),umax); %Analytical formulas for the minimum of the Hamiltonian
        w(i)=min(max(0,(-mu_w+lambda(i,1)*(alpha+beta*x(i,3))*x(i,1)+lambda(i,2)*(eta+delta*x(i,3))*x(i,2)-lambda(i,3)+2*epsilon*w(i))/(nu_w+2*epsilon)),wmax);
        Hnew(i)=sigma/2*x(i,1)^2+nu_u/2*u(i).*u(i)+nu_w/2*w(i).*w(i)...
                +mu_u*abs(u(i))+mu_w*abs(w(i))-lambda(i,1)...
                *(xi*x(i,1)*log(x(i,1)/x(i,2))+(alpha+beta*x(i,3))*x(i,1)*w(i))...
                +lambda(i,2)*(kappa*(b*x(i,2)^(2/3)-d*x(i,2)^(4/3))...
                +(1-kappa)*(b*x(i,1)-d*x(i,1)^(2/3)*x(i,2)))...
                -lambda(i,2)*(gamma*x(i,2)*u(i)+(eta+delta*x(i,3))*x(i,2)*w(i))...
                +lambda(i,3)*(-rho*x(i,3)+w(i));
end


for l=[-1.25,-1,0,1,2,3,4,5,6,8,10,15]
    count=0;
for i=1:n
        
        if (Hopt(i)-Hnew(i)<=10^(-l))
            count=count+1;
        end
   
end
ratio=count/n;
fprintf('l=%i: %f, ',l,ratio)
end

%max(Hopt-Hnew)
end

