function [] = optimal(u_1,u_2,fin,cd,OCP)
Nt=OCP.T/OCP.dt;
dx=OCP.dx;
N=((OCP.b-OCP.a)/OCP.dx);
alpha=OCP.alpha;
beta=OCP.beta;

fint=fok_pl(u_1,u_1,fin,1,OCP);
f(:,:,2:Nt)=fint(2:N,2:N,1:Nt-1);
f(:,:,1)=fint(2:N,2:N);
p=adj_fok_pl(u_1,u_2,cd,1,OCP);

u1(:,:,1:Nt)=u_1(2:N,2:N,1:Nt);
u2(:,:,1:Nt)=u_2(2:N,2:N,1:Nt);


for i=1:Nt
    dp1=(p(3:N+1,2:N,i)-p(1:N-1,2:N,i))/(2*dx);
    dp2=(p(2:N,3:N+1,i)-p(2:N,1:N-1,i))/(2*dx);
    for j=1:N-1
        for k=1:N-1
            Hopth(j,k)=(0.5*alpha*(u1(j,k,i).^2 + u2(j,k,i).^2) + beta*(abs(u1(j,k,i))+abs(u2(j,k,i))) ...
                    +u1(j,k,i)*dp1(j,k)+u2(j,k,i)*dp2(j,k))*f(j,k,i);
        end
    end
    Hopt(:,:,i)=Hopth;       
end

 for i=1:Nt
    dp1=(p(3:N+1,2:N,i)-p(1:N-1,2:N,i))/(2*dx);
    dp2=(p(2:N,3:N+1,i)-p(2:N,1:N-1,i))/(2*dx);
    u11=min(max(0,(-dp1-OCP.beta)/OCP.alpha),OCP.umax);
    u12=min(max(OCP.umin,(-dp1+OCP.beta)/OCP.alpha),0);
    u21=min(max(0,(-dp2-OCP.beta)/OCP.alpha),OCP.umax);
    u22=min(max(OCP.umin,(-dp2+OCP.beta)/OCP.alpha),0);
    for j=1:N-1
        for k=1:N-1
            VecVal=combvec([u11(j,k) u12(j,k)],[u21(j,k) u22(j,k)])';
            H1=(0.5*alpha*(VecVal(:,1).^2 + VecVal(:,2).^2) + beta*(abs(VecVal(:,1))+abs(VecVal(:,2))) ...
                    +VecVal(:,1)*dp1(j,k)+VecVal(:,2)*dp2(j,k))*f(j,k,i);
            [Hnewh(j,k),pos]=min(H1);
            u1h(j,k)=VecVal(pos,1);
            u2h(j,k)=VecVal(pos,2);
        end
    end
    Hnew(:,:,i)=Hnewh;
    u1(:,:,i)=u1h;
    u2(:,:,i)=u2h;
 end

fprintf('Max DH: %d\n',max(max(max(Hopt-Hnew))));
fprintf('Fraction of grid points where 0<=DH<=10^-l is fulfilled:\n')
for l=1:12 
count=0;
for i=1:Nt
    for j=1:N-1
        for o=1:N-1
        if (Hopt(j,o,i)-Hnew(j,o,i)<=10^-l)
            count=count+1;
        end
        end
    end
end
ratio=count/(Nt*(N-1)*(N-1));
fprintf('l=%i: %f\t',l,ratio);
end


fprintf('\n'); 



end

